cr = 
[[



  Copyright 2014 by Alex2009(www.Alex2009.de)

  Dieses Werk bzw. Inhalt von Alex2009 ist lizenziert unter einer Creative Commons Namensnennung - Nicht-kommerziell - Keine Bearbeitung 3.0 Unported Lizenz. 
  Um eine Kopie dieser Lizenz zu sehen, besuchen Sie http://creativecommons.org/licenses/by-nc-nd/3.0/deed.de
  ueber diese Lizenz hinausgehende Erlaubnisse koennen Sie unter http://www.Alex2009.de erhalten.



]]

PlaceableFenceDoor = {};
PlaceableFenceDoor_mt = Class(PlaceableFenceDoor, Placeable);
InitObjectClass(PlaceableFenceDoor, "PlaceableFenceDoor");

function PlaceableFenceDoor:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, PlaceableFenceDoor_mt);
    registerObjectClassName(self, "PlaceableFenceDoor");
    self.isSpecialPlaceable = true;
    return self;
end;

function PlaceableFenceDoor:delete()
    removeTrigger(self.doorTrigger);
    unregisterObjectClassName(self);
    PlaceableFenceDoor:superClass().delete(self);
end;

function PlaceableFenceDoor:deleteFinal()
    PlaceableFenceDoor:superClass().deleteFinal(self);
end;

function PlaceableFenceDoor:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
    if not PlaceableFenceDoor:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
        return false;
    end;
    if not moveMode then
        self.doorTrigger = Utils.indexToObject(self.nodeId,"0|0");
        addTrigger(self.doorTrigger, "triggerCallback", self);    
        self.Door = Utils.indexToObject(self.nodeId,"0");
        self.count = false; 
        self.isOpen = 0;
        self.angle = math.rad(0);
        self.maxAngle = math.rad(90);
        self.maxAngle1 = math.rad(90);
        self.maxAngle2 = math.rad(170);
        self.minAngle = math.rad(0);
        self.isEnabled = true;
    end;
    return true;
end;

function PlaceableFenceDoor:update(dt)
  if self.isEnabled then
    if self.count then
        if self.isOpen > 0 then
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Close_Fence_Dor"), self.typeDesc), InputBinding.Open_Fence_DorA);
        else
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Open_Fence_DorA"), self.typeDesc), InputBinding.Open_Fence_DorA);
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Open_Fence_DorB"), self.typeDesc), InputBinding.Open_Fence_DorB);
        end;
        if InputBinding.hasEvent(InputBinding.Open_Fence_DorA) then
            if self.isOpen == 0 then
                self.isOpen = 1;
            else
                self.isOpen = 0;
            end;
            PlaceableFenceDoorEvent.sendEvent(self, self.isOpen, self.maxAngle)
        end;
        if self.isOpen == 0 then
            if InputBinding.hasEvent(InputBinding.Open_Fence_DorB) then
                self.isOpen = 2;
                PlaceableFenceDoorEvent.sendEvent(self, self.isOpen, self.maxAngle)
            end;
        end;
        if self.isOpen == 0 then
            local radio = "90";
            if self.maxAngle == self.maxAngle2 then
                radio = "170";
            end;
            g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Fence_Dor_Radio"), self.typeDesc)..": "..radio, InputBinding.Fence_Dor_Radio);
            if InputBinding.hasEvent(InputBinding.Fence_Dor_Radio) then
                if self.maxAngle == self.maxAngle1 then
                    self.maxAngle = self.maxAngle2;
                else
                    self.maxAngle = self.maxAngle1;
                end;
            end;
        end;
    end
    local old = self.angle;
    if self.isOpen == 1 then
        if self.angle < self.maxAngle then
            self.angle = self.angle + dt*0.0006;    
        end;
    elseif self.isOpen == 2 then
        if self.angle > -self.maxAngle then
            self.angle = self.angle + dt*-0.0006;    
        end;
    elseif self.angle ~= 0 then
        if (self.angle < 0 and self.angle < self.minAngle) or (self.angle > self.minAngle) then
            if (self.angle < 0 and self.angle < self.minAngle) then
                self.angle = self.angle + dt*0.0006;    
            else
                self.angle = self.angle - dt*0.0006;  
            end;
            if (self.angle <= 0.004 and self.angle >= 0) or (self.angle >= -0.004 and self.angle <= -0) then
                self.angle = 0;
            end;
        end;
    end;
    if old ~= self.angle then
        local x,y,z = getRotation(self.Door);
        setRotation(self.Door,x,self.angle,z);
    end;
  end;
end;

function PlaceableFenceDoor:readStream(streamId, connection)
  PlaceableFenceDoor:superClass().readStream(self, streamId, connection);
  if self.isEnabled then
	self.isOpen = streamReadInt32(streamId);
    self.maxAngle = streamReadFloat32(streamId);
  end;
end;

function PlaceableFenceDoor:writeStream(streamId, connection)
  PlaceableFenceDoor:superClass().writeStream(self, streamId, connection);
  if self.isEnabled then
    streamWriteInt32(streamId, self.isOpen);
    streamWriteFloat32(streamId, self.maxAngle);
  end;
end;

function PlaceableFenceDoor:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay)  
    if onEnter and self.isEnabled and g_currentMission.controlPlayer and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        if g_currentMission.isMasterUser or self.isServer then
            self.count = true;
        end;
    elseif onLeave and self.isEnabled and g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode then
        self.count = false;
    end;
end;
registerPlaceableType("PlaceableFenceDoor", PlaceableFenceDoor);

PlaceableFenceDoorEvent = {};
PlaceableFenceDoorEvent_mt = Class(PlaceableFenceDoorEvent, Event);

InitEventClass(PlaceableFenceDoorEvent, "PlaceableFenceDoorEvent");

function PlaceableFenceDoorEvent:emptyNew()
    local self = Event:new(PlaceableFenceDoorEvent_mt);
    self.className = "PlaceableFenceDoorEvent";
    return self;
end;

function PlaceableFenceDoorEvent:new(object, torstate, tormax)
    local self = PlaceableFenceDoorEvent:emptyNew()
    self.object = object;
	self.torstate = torstate;
    self.tormax = tormax;
    return self;
end;

function PlaceableFenceDoorEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.torstate = streamReadInt32(streamId);
    self.tormax = streamReadFloat32(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function PlaceableFenceDoorEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteInt32(streamId, self.torstate);
    streamWriteFloat32(streamId, self.tormax);
end;

function PlaceableFenceDoorEvent:run(connection)
    self.object.isOpen = self.torstate;
    self.object.maxAngle = self.tormax;
    if not connection:getIsServer() then
        g_server:broadcastEvent(PlaceableFenceDoorEvent:new(self.object, self.torstate, self.tormax), nil, connection, self.object);
    end;
end;

function PlaceableFenceDoorEvent.sendEvent(object, torstate, tormax, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(PlaceableFenceDoorEvent:new(object, torstate, tormax), nil, nil, object);
        else
            g_client:getServerConnection():sendEvent(PlaceableFenceDoorEvent:new(object, torstate, tormax));
        end;
    end;
end;

local oldPlaceableObjectOverlapCallback = PlacementScreen.objectOverlapCallback;
PlacementScreen.objectOverlapCallback = function(self,transformId)
    if self.placeable == nil or self.placeable.isSpecialPlaceable == nil then
        oldPlaceableObjectOverlapCallback(self,transformId);
    end
end

local oldPlaceableObjectOverlapRaycastCallback = PlacementScreen.objectOverlapRaycastCallback;
PlacementScreen.objectOverlapRaycastCallback = function(self,hitObjectId, x, y, z, distance)
    if self.placeable == nil or self.placeable.isSpecialPlaceable == nil then
        oldPlaceableObjectOverlapRaycastCallback(self,hitObjectId, x, y, z, distance);
    end
end

local oldPlaceableHasObjectOverlap = PlacementScreen.hasObjectOverlap;
PlacementScreen.hasObjectOverlap = function(placeable, x, y, z, rotY)
    if placeable == nil or placeable.isSpecialPlaceable == nil then
        oldPlaceableHasObjectOverlap(placeable, x, y, z, rotY);
    end
end

local oldPlaceableIsInsidePlacementPlaces = PlacementScreen.isInsidePlacementPlaces;
PlacementScreen.isInsidePlacementPlaces = function(places, placeable, x, y, z)
    if placeable == nil or placeable.isSpecialPlaceable == nil then
        return oldPlaceableIsInsidePlacementPlaces(places, placeable, x, y, z)
    end
    return false
end

SpecialPlaceable = {};
SpecialPlaceable_mt = Class(SpecialPlaceable, Placeable);
InitObjectClass(SpecialPlaceable, "SpecialPlaceable");

function SpecialPlaceable:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, SpecialPlaceable_mt);
    registerObjectClassName(self, "SpecialPlaceable");
    self.isSpecialPlaceable = true;
    return self;
end;

function SpecialPlaceable:delete()
    unregisterObjectClassName(self);
    SpecialPlaceable:superClass().delete(self);
end;

function SpecialPlaceable:deleteFinal()
    SpecialPlaceable:superClass().deleteFinal(self);
end;

function SpecialPlaceable:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
    if not SpecialPlaceable:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
        return false;
    end;
    return true;
end;

function SpecialPlaceable:update(dt)
end;

function SpecialPlaceable:readStream(streamId, connection)
  SpecialPlaceable:superClass().readStream(self, streamId, connection);
end;

function SpecialPlaceable:writeStream(streamId, connection)
  SpecialPlaceable:superClass().writeStream(self, streamId, connection);
end;
registerPlaceableType("SpecialPlaceable", SpecialPlaceable);